tinymce.IconManager.add("ssmlicons", {
  icons: {
    break:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/break.png" class="ssmlicon" />',
    emphasis:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/emphasis.png" class="ssmlicon" />',
    prosody:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/prosody.png" class="ssmlicon" />',
    prosodymax:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/prosody-amazon-max-duration.png" class="ssmlicon" />',
    speak:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/speak.png" class="ssmlicon" />',
    s:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/s.png" class="ssmlicon" />',
    sayas:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/say-as.png" class="ssmlicon" />',
    phoneme:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/phoneme.png" class="ssmlicon" />',
    newscaster:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/newscaster.png" class="ssmlicon" />',
    sub:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/sub.png" class="ssmlicon" />',
    w:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/w.png" class="ssmlicon" />',
    cross:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/remove.png" style="margin-left:10px" class="ssmlicon" />',
    mark:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/mark.png" style="margin-left:10px" class="ssmlicon" />',
    lang:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/lang.png" style="margin-left:10px" class="ssmlicon" />',
    breath:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/auto-breath.png" style="margin-left:10px" class="ssmlicon" />',
    amafect:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/dynamic-range-compression.png" style="margin-left:10px" class="ssmlicon" />',
    soft:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/Speak-Soft.png" style="margin-left:10px" class="ssmlicon" />',
    vtl:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/Controlling-Timbre.png" style="margin-left:10px" class="ssmlicon" />',
    whisper:
      '<img src="' +
      ssmlp.pluginurl +
      '/assets/images/Whispered.png" style="margin-left:10px" class="ssmlicon" />',
    sound:
      '<img src="' +
      ssmlp.pluginurl +
      'assets/images/music.png" style="margin-left:10px" class="ssmlicon" />',
    help:
      '<img src="' +
      ssmlp.pluginurl +
      'assets/images/help.png" style="margin-left:10px" class="ssmlicon" />',
  },
});

//Loader
var ssmlp_loader =
  `<div class="ssmlp_loader">
    <img src="` +
  ssmlp.pluginurl +
  `/assets/images/loader.gif"/>
  </div>`;

function ssmleditor_addbuttons(editor) {
  editor.ui.registry.addButton("sound", {
    text: "Sound",
    icon: "sound",
    tooltip: "add sound tag",
    onAction: () => {
      editor.windowManager.open({
        title: 'Apply SSML "Sound" ',
        body: {
          type: "panel",
          items: [
            {
              type: "input",
              name: "sound_src",
              label: "Link",
              placeholder: "Insert sound link here",
            },
          ],
        },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var sound = e.getData().sound_src;
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var tag = "";
          tag += "<sound ";
          tag += 'src = "' + sound + '"></sound>' + text;
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("cross", {
    text: "",
    icon: "cross",
    tooltip: "Remove selected tag",
    onAction: () => {
      var text = tinymce.activeEditor.selection.getNode();
      var content = tinymce.activeEditor.getContent();
      content = content.replace(
        text.outerHTML.replace("&nbsp;", " "),
        text.innerHTML.replace("&nbsp;", " ")
      );
      tinymce.activeEditor.setContent(content);
    },
  });

  editor.ui.registry.addButton("speak", {
    text: "Speak",
    icon: "speak",
    tooltip: "Identify SSML-Enhanced Text",
    onAction: () => {
      var text = tinymce.activeEditor.selection.getContent({ format: "text" });
      var tag = "";
      tag += "<speak>" + text + "</speak>&nbsp;";
      editor.insertContent(tag);
    },
  });

  editor.ui.registry.addButton("break", {
    text: "Break",
    icon: "break",
    tooltip: "Adding a pause",
    onAction: () => {
      editor.windowManager.open({
        title: 'Apply SSML "Break" ',
        body: {
          type: "panel",
          items: [
            {
              type: "selectbox",
              name: "strength",
              label: "Strength",
              items: [
                { value: "none", text: "none" },
                { value: "x-weak", text: "x-weak" },
                { value: "weak", text: "weak" },
                { value: "medium", text: "medium" },
                { value: "strong", text: "strong" },
                { value: "x-strong", text: "x-strong" },
              ],
            },
            {
              type: "input",
              name: "time",
              label: "Time",
              width: "50%",
              placeholder: "The maximum duration is 10s",
            },
          ],
        },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var strength = e.getData().strength;
          var time = e.getData().time;
          var tag = "";
          tag += "<break ";
          tag += 'strength = "' + strength + '" ';
          if (time != "") tag += 'time = "' + time + 's" ';
          tag += "/>" + text;
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("emphasis", {
    text: "Emphasis",
    icon: "emphasis",
    tooltip: "Emphasizing words",
    onAction: () => {
      var levelVal = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "level"
      );
      if (levelVal != undefined) levelVal = levelVal;
      else levelVal = "strong";

      editor.windowManager.open({
        title: 'Apply SSML "Emphasis" ',
        body: {
          type: "panel",
          items: [
            {
              type: "selectbox",
              name: "level",
              label: "Level",
              items: [
                { value: "strong", text: "strong" },
                { value: "moderate", text: "moderate" },
                { value: "reduced", text: "reduced" },
              ],
            },
          ],
        },
        initialData: { level: levelVal },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var level = e.getData().level;
          var tag = "";
          tag += "<emphasis ";
          tag += 'level = "' + level + '">' + text + "</emphasis>&nbsp;";
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("prosody", {
    text: "Prosody",
    icon: "prosody",
    tooltip: "Controlling Volume, Speaking Rate, and Pitch",
    onAction: () => {
      var vol = jQuery(tinymce.activeEditor.selection.getNode()).attr("volume");
      var rate = jQuery(tinymce.activeEditor.selection.getNode()).attr("rate");
      var pitch = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "pitch"
      );
      var vol_custom = "";
      var rate_custom = "";
      var pitch_custom = "";
      if (vol != undefined) vol = vol;
      else vol = "";

      if (rate != undefined) rate = rate;
      else rate = "";

      if (pitch != undefined) pitch = pitch;
      else pitch = "";

      if (Number(vol)) {
        vol_custom = vol;
        vol = "custom";
      } else {
        vol_custom = "";
      }

      if (Number(rate)) {
        rate_custom = rate;
        rate = "custom";
      } else {
        rate_custom = "";
      }

      if (Number(pitch)) {
        pitch_custom = pitch;
        pitch = "custom";
      } else {
        pitch_custom = "";
      }

      editor.windowManager.open({
        title: 'Apply SSML "Prosody" ',
        body: {
          type: "panel",
          items: [
            {
              type: "bar",
              items: [
                {
                  type: "selectbox",
                  name: "volume",
                  label: "Volume",
                  items: [
                    { value: "", text: "not set" },
                    { value: "default", text: "default" },
                    { value: "silent", text: "silent" },
                    { value: "x-soft", text: "x-soft" },
                    { value: "soft", text: "soft" },
                    { value: "medium", text: "medium" },
                    { value: "loud", text: "loud" },
                    { value: "x-loud", text: "x-loud" },
                    { value: "custom", text: "input in +ndB or -ndB" },
                  ],
                },
                {
                  type: "input",
                  name: "custom_vol",
                  label: "Custom Volume",
                  placeholder: "+ndB or -ndB",
                  disabled: vol != "custom",
                },
              ],
            },
            {
              type: "bar",
              items: [
                {
                  type: "selectbox",
                  name: "rate",
                  label: "Rate",
                  items: [
                    { value: "", text: "not set" },
                    { value: "x-slow", text: "x-slow" },
                    { value: "slow", text: "slow" },
                    { value: "medium", text: "medium" },
                    { value: "fast", text: "fast" },
                    { value: "x-fast", text: "x-fast" },
                    { value: "custom", text: "input in percentage%" },
                  ],
                },
                {
                  type: "input",
                  name: "custom_rate",
                  label: "Custom Rate",
                  placeholder: "Enter rate in %",
                  disabled: rate != "custom",
                },
              ],
            },
            {
              type: "bar",
              items: [
                {
                  type: "selectbox",
                  name: "pitch",
                  label: "Pitch",
                  items: [
                    { value: "", text: "not set" },
                    { value: "default", text: "default" },
                    { value: "x-low", text: "x-low" },
                    { value: "low", text: "low" },
                    { value: "medium", text: "medium" },
                    { value: "high", text: "high" },
                    { value: "x-high", text: "x-high" },
                    { value: "custom", text: "input in +n% or -n%" },
                  ],
                },
                {
                  type: "input",
                  name: "custom_pitch",
                  label: "Custom pitch",
                  placeholder: "input in +n% or -n%",
                  disabled: pitch != "custom",
                },
              ],
            },
          ],
        },
        initialData: {
          volume: vol,
          custom_vol: vol_custom,
          rate: rate,
          custom_rate: rate_custom,
          pitch: pitch,
          custom_pitch: pitch_custom,
        },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onChange: (e, details) => {
          if (e.getData().volume == "custom") {
            e.enable("custom_vol");
          } else {
            e.disable("custom_vol");
          }
          if (e.getData().rate == "custom") {
            e.enable("custom_rate");
          } else {
            e.disable("custom_rate");
          }
          if (e.getData().pitch == "custom") {
            e.enable("custom_pitch");
          } else {
            e.disable("custom_pitch");
          }
        },
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var volume;
          var rate;
          var pitch;
          if (e.getData().volume == "custom") {
            volume = e.getData().custom_vol;
          } else {
            volume = e.getData().volume;
          }
          if (e.getData().rate == "custom") {
            rate = e.getData().custom_rate;
            rate = rate.replace("%", "");
            if (rate > 200 || rate < 20) {
              alert("Rate limit crossed! Please try between 20% to 200%");
              e.preventDefault();
            }
            rate = rate + "%";
          } else {
            rate = e.getData().rate;
          }
          if (e.getData().pitch == "custom") {
            pitch = e.getData().custom_pitch;
          } else {
            pitch = e.getData().pitch;
          }

          var tag = "";
          tag += "<prosody ";
          if (volume != "") {
            tag += 'volume="' + volume + '" ';
          }
          if (rate != "") {
            tag += 'rate="' + rate + '" ';
          }
          if (pitch != "") {
            tag += 'pitch="' + pitch + '"';
          }

          tag += '">' + text + "</prosody>&nbsp;";
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("prosodymax", {
    text: "Prosody Max",
    icon: "prosodymax",
    tooltip: "Setting a Maximum Duration for Synthesized Speech",
    onAction: () => {
      var promaxVal = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "amazon-max-duration"
      );
      if (promaxVal != undefined) promaxVal = promaxVal.replace("s", "");
      else promaxVal = "1";

      editor.windowManager.open({
        title: 'Apply SSML "Prosody Amazon:Max-Duration" ',
        body: {
          type: "panel",
          items: [
            {
              type: "input",
              name: "promax",
              label: "Amazon:Max-Duration",
            },
          ],
        },
        initialData: { promax: promaxVal },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var time = e.getData().promax;
          var tag = "";
          tag += "<prosody ";
          tag +=
            'amazon-max-duration="' + time + 's">' + text + "</prosody>&nbsp;";
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("say_as", {
    text: "Say As",
    icon: "sayas",
    tooltip: "Controlling How Special Types of Words Are Spoken",
    onAction: () => {
      var Val = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "interpret-as"
      );
      if (Val != undefined) Val = Val;
      else Val = "cardinal";

      editor.windowManager.open({
        title: 'Apply SSML "Say As" ',
        body: {
          type: "panel",
          items: [
            {
              type: "selectbox",
              name: "say",
              label: "interpret as",
              items: [
                { value: "cardinal", text: "cardinal" },
                { value: "ordinal", text: "ordinal" },
                { value: "digits", text: "digits" },
                { value: "fraction", text: "fraction" },
                { value: "unit", text: "unit" },
                { value: "date", text: "date" },
                { value: "time", text: "time" },
                { value: "address", text: "address" },
                { value: "expletive", text: "expletive" },
                { value: "telephone", text: "telephone" },
              ],
            },
          ],
        },
        initialData: { say: Val },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var say = e.getData().say;
          var tag = "";
          tag += "<say-as ";
          tag += 'interpret-as = "' + say + '">' + text + "</say-as>&nbsp;";
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("sub", {
    text: "Sub",
    icon: "sub",
    tooltip: "Pronouncing Acronyms and Abbreviations",
    onAction: () => {
      var alias = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "alias"
      );
      if (alias != undefined) alias = alias;
      else alias = "";

      editor.windowManager.open({
        title: 'Apply SSML "Sub" ',
        body: {
          type: "panel",
          items: [
            {
              type: "input",
              name: "alias",
              label: "alias",
              disabled: false,
            },
          ],
        },
        initialData: { alias: alias },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var alias = e.getData().alias;
          var tag = "";
          tag += "<sub ";
          tag += 'alias="' + alias + '">' + text + "</sub>&nbsp;";
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("mark", {
    text: "Mark",
    icon: "mark",
    tooltip: "Placing a Custom Tag in Your Text",
    onAction: () => {
      var markVal = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "name"
      );
      if (markVal != undefined) markVal = markVal;
      else markVal = "";
      editor.windowManager.open({
        title: 'Apply SSML "Mark" ',
        body: {
          type: "panel",
          items: [
            {
              type: "input",
              name: "mark",
              label: "Name",
              placeholder: "Name",
              disabled: false,
            },
          ],
        },
        initialData: { mark: markVal },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var mark = e.getData().mark;
          var tag = "";
          tag += "<mark ";
          tag += 'name="' + mark + '"/>&nbsp;' + text;
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("language", {
    text: "Lang",
    icon: "lang",
    tooltip: "Specifying Another Language for Specific Words",
    onAction: () => {
      var langVal = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "xml:lang"
      );
      if (langVal != undefined) langVal = langVal;
      else langVal = "arb";

      editor.windowManager.open({
        title: 'Apply SSML "Language" ',
        body: {
          type: "panel",
          items: [
            {
              type: "selectbox",
              name: "lang",
              label: "Language",
              items: [
                { value: "arb", text: "Arabic" },
                { value: "cmn-CN", text: "Chinese, Mandarin" },
                { value: "da-DK", text: "Danish" },
                { value: "nl-NL", text: "Dutch" },
                { value: "en-AU", text: "English, Australian" },
                { value: "en-GB", text: "English, British" },
                { value: "en-IN", text: "English, Indian" },
                { value: "en-US", text: "English, US" },
                { value: "en-GB-WLS", text: "English, Welsh" },
                { value: "fr-FR", text: "French" },
                { value: "fr-CA", text: "French, Canadian" },
                { value: "hi-IN", text: "Hindi" },
                { value: "de-DE", text: "German" },
                { value: "is-IS", text: "Icelandic" },
                { value: "it-IT", text: "Italian" },
                { value: "ja-JP", text: "Japanese" },
                { value: "ko-KR", text: "Korean" },
                { value: "nb-NO", text: "Norwegian" },
                { value: "pl-PL", text: "Polish" },
                { value: "pt-BR", text: "Portuguese, Brazilian" },
                { value: "pt-PT", text: "Portuguese, European" },
                { value: "ro-RO", text: "Romanian" },
                { value: "ru-RU", text: "Russian" },
                { value: "es-ES", text: "Spanish, European" },
                { value: "es-MX", text: "Spanish, Mexican" },
                { value: "es-US", text: "Spanish, US" },
                { value: "sv-SE", text: "Swedish" },
                { value: "tr-TR", text: "Turkish" },
                { value: "cy-GB", text: "Welsh" },
              ],
            },
          ],
        },
        initialData: { lang: langVal },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var lang = e.getData().lang;
          var tag = "";
          tag += "<lang  ";
          tag += 'xml:lang="' + lang + '">' + text + "</lang>&nbsp;";
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("phoneme", {
    text: "Phoneme",
    icon: "phoneme",
    tooltip: "Phonetic Pronunciation",
    onAction: () => {
      jQuery('#phoneme-modal').show();
      jQuery(".phoneme-dy-fields").empty();
      jQuery(".phoneme-ph").val('');
      jQuery('.phoneme-ph').val(tinymce.activeEditor.selection.getContent({
        format: "text",
      }));
      return
    },
  });

  editor.ui.registry.addButton("breath", {
    text: "Breath",
    icon: "breath",
    onAction: () => {
      editor.windowManager.open({
        title: 'Apply SSML "Breath" ',
        body: {
          type: "panel",
          items: [
            {
              type: "selectbox",
              name: "duration",
              label: "duration",
              items: [
                { value: "default", text: "default" },
                { value: "x-short", text: "x-short" },
                { value: "short", text: "short" },
                { value: "medium", text: "medium" },
                { value: "long", text: "long" },
                { value: "x-long", text: "x-long" },
              ],
            },
            {
              type: "selectbox",
              name: "volume",
              label: "volume",
              items: [
                { value: "default", text: "default" },
                { value: "x-soft", text: "x-soft" },
                { value: "soft", text: "soft" },
                { value: "medium", text: "medium" },
                { value: "loud", text: "loud" },
                { value: "x-loud", text: "x-loud" },
              ],
            },
          ],
        },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var duration = e.getData().duration;
          var volume = e.getData().volume;
          var tag = "";
          tag += "<amazon:breath  ";
          tag += 'duration="' + duration + '" ';
          tag += 'volume="' + volume + '"/> ' + text;
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("auto-breaths", {
    text: "Auto Breath",
    icon: "breath",
    tooltip: "Adding the Sound of Breathing",
    onAction: () => {
      var durationVal = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "duration"
      );
      var frequencyVal = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "frequency"
      );
      var volumeVal = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "volume"
      );
      if (durationVal != undefined) durationVal = durationVal;
      else durationVal = "";

      if (frequencyVal != undefined) frequencyVal = frequencyVal;
      else frequencyVal = "";

      if (volumeVal != undefined) volumeVal = volumeVal;
      else volumeVal = "";

      editor.windowManager.open({
        title: 'Apply SSML "Auto Breath" ',
        body: {
          type: "panel",
          items: [
            {
              type: "selectbox",
              name: "duration",
              label: "duration",
              items: [
                { value: "", text: "none" },
                { value: "default", text: "default" },
                { value: "x-short", text: "x-short" },
                { value: "short", text: "short" },
                { value: "medium", text: "medium" },
                { value: "long", text: "long" },
                { value: "x-long", text: "x-long" },
              ],
            },
            {
              type: "selectbox",
              name: "frequency",
              label: "frequency",
              items: [
                { value: "", text: "none" },
                { value: "default", text: "default" },
                { value: "x-low", text: "x-low" },
                { value: "low", text: "low" },
                { value: "medium", text: "medium" },
                { value: "high", text: "high" },
                { value: "x-high", text: "x-high" },
              ],
            },
            {
              type: "selectbox",
              name: "volume",
              label: "volume",
              items: [
                { value: "", text: "none" },
                { value: "default", text: "default" },
                { value: "x-soft", text: "x-soft" },
                { value: "soft", text: "soft" },
                { value: "medium", text: "medium" },
                { value: "loud", text: "loud" },
                { value: "x-loud", text: "x-loud" },
              ],
            },
          ],
        },
        initialData: {
          duration: durationVal,
          frequency: frequencyVal,
          volume: volumeVal,
        },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var duration = e.getData().duration;
          var frequency = e.getData().frequency;
          var volume = e.getData().volume;
          var tag = "";
          tag += "<amazon:auto-breaths ";
          if (duration != "") {
            tag += 'duration="' + duration + '" ';
          }
          if (frequency != "") {
            tag += 'frequency="' + frequency + '" ';
          }
          if (volume != "") {
            tag += 'volume="' + volume + '"';
          }
          tag += ">" + text + "</amazon:auto-breaths>&nbsp;";
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("News", {
    text: "Newscaster",
    icon: "newscaster",
    tooltip: "Newscaster speaking style",
    onAction: () => {
      var text = tinymce.activeEditor.selection.getContent({ format: "text" });
      var tag = "";
      tag += "<amazon:domain ";
      tag += 'name="news">' + text + "</amazon:domain>&nbsp;";
      editor.insertContent(tag);
      editor.windowManager.close();
    },
  });

  editor.ui.registry.addButton("amazon:effect", {
    text: "DRC",
    icon: "amafect",
    tooltip: "Adding Dynamic Range Compression",
    onAction: () => {
      var text = tinymce.activeEditor.selection.getContent({ format: "text" });
      var tag = "";
      tag += "<amazon:effect ";
      tag += 'name="drc">' + text + "</amazon:effect>&nbsp;";
      editor.insertContent(tag);
      editor.windowManager.close();
    },
  });

  editor.ui.registry.addButton("speaking_softly", {
    text: "Soft",
    icon: "soft",
    tooltip: "Speaking softly",
    onAction: () => {
      var text = tinymce.activeEditor.selection.getContent({ format: "text" });
      var tag = "";
      tag += "<amazon:effect ";
      tag += 'phonation="soft">' + text + "</amazon:effect>&nbsp;";
      editor.insertContent(tag);
      editor.windowManager.close();
    },
  });

  editor.ui.registry.addButton("controlling_timbre", {
    text: "VTL",
    icon: "vtl",
    tooltip: "Controlling Timbre",
    onAction: () => {
      var vtlVal = jQuery(tinymce.activeEditor.selection.getNode()).attr(
        "vocal-tract-length"
      );
      if (vtlVal != undefined) vtlVal = vtlVal;
      else vtlVal = "";

      editor.windowManager.open({
        title: 'Apply SSML "vocal-track-length" ',
        body: {
          type: "panel",
          items: [
            {
              type: "input",
              name: "vtl",
              label: "vocal-tract-length",
              placeholder: "enter vocal-track-length b/w -50% to +100%",
            },
          ],
        },
        initialData: { vtl: vtlVal },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var vtl = e.getData().vtl;

          if (e.getData().vtl >= -50 && e.getData().vtl <= +100) {
            var text = tinymce.activeEditor.selection.getContent({
              format: "text",
            });
            var tag = "";
            tag += "<amazon:effect ";
            tag +=
              'vocal-tract-length="' +
              vtl +
              '%">' +
              text +
              "</amazon:effect>&nbsp;";
            editor.insertContent(tag);
            editor.windowManager.close();
          } else if (e.getData().vtl <= -50) {
            var tag = "";
            tag += "<amazon:effect  ";
            tag += 'vocal-tract-length="-50%">' + text;
            editor.insertContent(tag);
            editor.windowManager.close();
          } else if (e.getData().vtl >= +100) {
            var tag = "";
            tag += "<amazon:effect  ";
            tag +=
              'vocal-tract-length="+100%">' + text + "</amazon:effect>&nbsp;";
            editor.insertContent(tag);
            editor.windowManager.close();
          }
        },
      });
    },
  });

  editor.ui.registry.addButton("w", {
    text: "W",
    icon: "w",
    tooltip: "Improving Pronunciation by Specifying Parts of Speech",
    onAction: () => {
      var role = jQuery(tinymce.activeEditor.selection.getNode()).attr("role");
      if (role != undefined) role = role;
      else role = "";

      editor.windowManager.open({
        title: 'Apply SSML "W" ',
        body: {
          type: "panel",
          items: [
            {
              type: "selectbox",
              name: "role",
              label: "Role",
              items: [
                { value: "amazon:VB", text: "amazon:VB" },
                { value: "amazon:VBD", text: "amazon:VBD" },
                { value: "amazon:SENSE_1", text: "amazon:SENSE_1" },
              ],
            },
          ],
        },
        initialData: { role: role },
        buttons: [
          {
            type: "submit",
            text: "OK",
          },
        ],
        onSubmit: (e) => {
          var text = tinymce.activeEditor.selection.getContent({
            format: "text",
          });
          var role = e.getData().role;
          var tag = "";
          tag += "<w ";
          tag += ' role="' + role + '">' + text + "</w>&nbsp;";
          editor.insertContent(tag);
          editor.windowManager.close();
        },
      });
    },
  });

  editor.ui.registry.addButton("S", {
    text: "S",
    icon: "s",
    tooltip: "Adding a Pause Between Sentences",
    onAction: () => {
      var text = tinymce.activeEditor.selection.getContent({ format: "text" });
      var a = text.replace(" ", "a");
      var tag = "";
      if (text != "") {
        tag += "<s";
        tag += ">" + text + "</s>&nbsp;";
        editor.insertContent(tag);
      }
    },
  });

  editor.ui.registry.addButton("whispered", {
    text: "Whispered",
    icon: "whisper",
    tooltip: "Whispering",
    onAction: () => {
      var text = tinymce.activeEditor.selection.getContent({ format: "text" });
      var tag = "";
      tag += "<amazon:effect ";
      tag += 'name="whispered">' + text + "</amazon:effect>&nbsp;";
      editor.insertContent(tag);
      editor.windowManager.close();
    },
  });

  editor.ui.registry.addButton("video", {
    text: "Resources",
    icon: "help",
    tooltip: "Training Videos about how to use editor",

    onAction: (e) => {
      if (video_url != "") {
        window.open(video_url);
      } else {
        alert(
          "Video Link is not updated, Please go into the Settings of SSML Processor and update the link."
        );
        e.setDisabled("video");
      }
      // editor.windowManager.openUrl({
      //   title: "Just a title",
      //   url: "https://sitex.digital/", https://www.youtube.com/
      // });
    },
  });
}

tinymce.init({
  selector: "#ssmlp_editor",
  branding: false,
  body_class: "ssmlp",
  entity_encoding: "raw",
  cleanup: true,
  content_css: ssmlp.pluginurl + "/assets/css/style.css",
  //custom_elements: "emphasis, lang, mark, phoneme, sub, w, prosody, s, amazon:domain, amazon:effect, say-as,breath,auto-breath",
  valid_elements:
    "p,img[src|class],break[strength|time],emphasis[level],lang[xml:lang],mark[name],phoneme[alphabet|ph],sub[alias],w[role],prosody[volume|rate|pitch|amazon-max-duration],s,amazon:domain[name],amazon:effect[name|phonation|vocal-tract-length],say-as[interpret-as],amazon:breath[duration|volume],amazon:auto-breaths[duration|volume|frequency],sound[src]",
  menubar: false,
  plugins: "code",
  icons: "ssmlicons",
  toolbar:
    "undo redo cross break emphasis language mark phoneme prosody prosodymax s say_as sub w breath auto-breaths News amazon:effect speaking_softly controlling_timbre whispered code video  ", //hidden( pronunciation,sound)
  setup: (editor) => {
    // for restricting character count
    editor.on("keyup", function (editor, evt) {
      ssmleditor_updateCharCounter(this, editor);
    });

    ssmleditor_addbuttons(editor);
    ssmleditor_phoneme(editor)
  },
  init_instance_callback: function (editor) {
    jQuery("#" + this.id)
      .next()
      .find(".tox-statusbar")
      .append(
        '<div id="' +
          this.id +
          '_char_count" class="char_count" style="text-align:right"></div>'
      );
    ssmleditor_updateCharCounter(this);
  },
});

function ssmleditor_updateCharCounter(el) {
  var ssml = tinyMCE.activeEditor.getContent();
  var cleantext = ssml.replace(/<.*?>/g, "");
  cleantext = cleantext.trim();

  var max_chars = jQuery("#ssml_allowed_chars").val();
  var nchars = cleantext.length;
  jQuery("#" + el.id + "_char_count").text("Characters: " + nchars);

  if (max_chars) {
    if (nchars <= max_chars && nchars != 0) {
      jQuery("#" + el.id + "_char_count").css("color", "green");
      jQuery("#ssmlp_btnprocess").css("background-color", "#222");
      jQuery("#ssmlp_btnprocess").prop("disabled", false);
    } else {
      jQuery("#" + el.id + "_char_count").css("color", "red");
      jQuery("#ssmlp_btnprocess").css("background-color", "#cacaca");
      jQuery("#ssmlp_btnprocess").prop("disabled", true);
    }
  }
}


function ssmleditor_phoneme(editor) {
  jQuery( document ).ready(function() {
    jQuery(document).on("click",".get-phoneme-results", async function() {
        // var text = tinymce.activeEditor.selection.getContent({
        //   format: "text",
        // });
        var text = jQuery('.phoneme-ph').val();
        
        if(!text) return alert('Please highlight a word in the editor’s text area, tag the word with the Phoneme tag, and then select the Get button.')
        if (text.split(" ").length > 1) return alert("Phoneme can be applied to a word only");
  
        text = text.replace(/[^a-zA-Z ]/g, "");
        text = text.replaceAll(" ", "_");
  
        const alphabet = jQuery('.phoneme-alphabet').find(":selected").val()

        jQuery(".ssmlp_loader").show();
        
        let result = await fetch(`${base_url}/wp-json/ssml/v1/phoneme/${text}/${alphabet}`)
        result = await result.json(result)

        jQuery(".ssmlp_loader").hide();
  
        if(!result.status) {
          return alert(result.errorMessage)
        }
  
        let html_fields = '';
  
        result.text.forEach((e, i) => {
          html_fields += `
            <div class="form-group" style="position:relative;display:block;width:50%;">
              <label class="ph_label" for="Ipa-spelling-${i}">IPA Spelling ${i + 1}</label>
              <input id="Ipa-spelling-${i}" type="text" class="ipa_spell" value="${e}" />
              <button class="use-phoneme-result use_btn" data-value="${e}">Use</button>
              <button class="play-ipa-audio ipa_audio_btn" id="ipa-toggle-${i}" data-ipa="${e}" data-index="${i}" data-text="${text}"><i class="fa fa-volume-up" aria-hidden="true" data-audioAtt="playBtn-${i}"></i></button>
              <audio id="ipa_playAudio${i}" class="ipa-audios" style="display:none;" autoplay>
            </div>
          `
        })
  
        jQuery(".phoneme-dy-fields").html(html_fields);
    });

    jQuery(document).on("click",".link-btn", function() {
      var URL =
      "https://developer.amazon.com/en-US/docs/alexa/custom-skills/speech-synthesis-markup-language-ssml-reference.html#phoneme";
    window.open(URL);
    })
  
    jQuery(document).on("click",".use-phoneme-result", function() {
      jQuery(".ssmlp_loader").show();
      const value = jQuery(this).data('value');
      jQuery('.phoneme-ipa').val(value)
      setTimeout(function() {
        jQuery(".ssmlp_loader").hide();
      }, 300);
    });

    jQuery(document).on("click",".play-ipa-audio", async function() {
      const ipaValue = jQuery(this).data('ipa')
      const index = jQuery(this).data('index')
      const text = jQuery(this).data('text')
      // jQuery("i", this).toggleClass("fa-play-circle fa-volume-up")
      // const instance = await ipa_audio(ipaValue, index, text)
      // instance.on('ended', function() {
      //   // console.log('audio ended')
      //   jQuery("i", '#ipa-toggle-'+index).toggleClass("fa-volume-up fa-play-circle")
      //   instance.off()
      // });
      return await ipa_audio(ipaValue, index, text)
    });
  
    jQuery(document).on("click",".phoneme-submit", function() {
      jQuery('#phoneme-modal').hide();
  
      const text = tinymce.activeEditor.selection.getContent({
        format: "text",
      });
  
      const alphabet = jQuery('.phoneme-alphabet').find(":selected").val()
      const ph = jQuery('.phoneme-ipa').val()
  
      if(!ph) return alert('Please select a Use button of an ipa spelling that you want to use before pressing OK!')
  
      //for x-sampa value
      let ph_val = ph.replace('"',"'");
      
      var tag = `<phoneme ph="${ph_val}" alphabet="${alphabet}">${text}</phoneme>`;
      editor.insertContent(tag);
      editor.windowManager.close();
    });

    jQuery(document).on("change", ".phoneme-alphabet", function() {
      const value = jQuery(this).val();
      if(value === 'x-sampa') {
        jQuery(".phoneme-dy-fields").empty();
        jQuery(".phoneme-ph").val('');
        jQuery(".phoneme-ph").hide();
        jQuery(".get-phoneme-results").hide();
        jQuery(".word_search").hide();
        jQuery(".link-btn").hide();
        jQuery('.phoneme-ipa').css('display','block');
        jQuery('.phoneme-ipa').val('');
        // jQuery(".phoneme-word").hide();
      }else {
        var text = tinymce.activeEditor.selection.getContent({
          format: "text",
        });
        jQuery(".get-phoneme-results").show();
        jQuery(".word_search").show();
        jQuery(".link-btn").show();
        jQuery(".phoneme-ipa").hide();
        jQuery(".phoneme-ph").show();
        jQuery(".phoneme-ph").val(text);
        // jQuery(".phoneme-word").show();
      }
    })
  });

}
