<?php
/*
Plugin Name: SSML Processor
Plugin URI: https://isqr.io/
Description: SSML Processor converts the SSML to Audio using Amazon Webservices.
Author: Ken Weatherford
Version: 0.3
*/

// function to return api response after event triggered from get button of phoneme
function addProject($data) {
  try {

    global $wpdb;

    $date = date('Y-m-d H:i:s');
    $projName = $data['text'];
    $projName =str_replace("%20"," ","$projName");
    $userId = $data['user_id'];
    $rowsFiles = $wpdb->get_results("INSERT INTO `wp_ssmlp_project` ( `name`, `created_by`, `created_on`) VALUES ( '$projName', '$userId', '$date');");
    return array(
      'status' => true,
      'type' => 'api',
      'data' => $rowsFiles
    );
  }catch(Exception $e) {
    return array(
      'status' => false,
      'errorMessage' => 'File Not found!'
    );
  }
}
function loadProject($data) {
  try {
    global $wpdb;
    $userId = $data['text'];
    $rowsFiles = $wpdb->get_results("SELECT * FROM wp_ssmlp_project  where created_by= '$userId' ORDER BY id DESC ");
    return array(
      'status' => true,
      'type' => 'api',
      'data' => $rowsFiles
    );
  }catch(Exception $e) {
    return array(
      'status' => false,
      'errorMessage' => 'File Not found!'
    );
  }
}

function processProjName($data) {
  try {
    global $wpdb;
    $selectedValue = $data['text'];
    $rowsFiles = $wpdb->get_results("SELECT fl.id, fl.file_name,fl.text,fl.url,fl.date,fl.project_id FROM `wp_ssmlp_history` as fl INNER JOIN wp_ssmlp_project as pr ON fl.project_id = pr.id WHERE fl.project_id ='$selectedValue' AND deleted = 0  ORDER BY id DESC  ");
    return array(
      'status' => true,
      'type' => 'api',
      'data' => $rowsFiles
    );
  }catch(Exception $e) {
    return array(
      'status' => false,
      'errorMessage' => 'File Not found!'
    );
  }
}

function deleteProject($data) {
  try {
    global $wpdb;
    $ProjectId = $data['text'];
    $rowsFiles = $wpdb->get_results("DELETE FROM `wp_ssmlp_project` WHERE `wp_ssmlp_project`.`id` ='$ProjectId'");
    return array(
      'status' => true,
      'type' => 'api',
      'data' => $rowsFiles
    );
  }catch(Exception $e) {
    return array(
      'status' => false,
      'errorMessage' => 'File Not found!'
    );
  }
}
function easy_pronunciation( $data ) {
  try {
    global $wpdb;
    $phrase = $data['text'];
    $phrase = str_replace('_',' ', $phrase);
    $phrase = urlencode($phrase);
    $alphabet_type = $data['format'];
    $url = "https://easypronunciation.com/english-api.php?access_token=8622f86452e73cdbd85c4883c29d8b1d&version=2&phrase=$phrase&english_phonetics_algorithm=american_miscellaneous_sources&Convert_to_english=$alphabet_type&add_aspiration_symbol=1&narrow_transcription=1&r_replacement=1&cot_caught_merger=1&er_replacement=1&elongation_symbol_after_i_and_u=always&only_i_for_es_ed_endings=0&show_rare_pronunciations=1&spell_numbers=1";

    $select_qry =  "SELECT * FROM `wp_phoneme_ipa` WHERE phrase = '$phrase'";
    $ph_results = $wpdb->get_results($select_qry);

    if(count($ph_results) != 0) {
      foreach($ph_results as $ipa_array) {
        $ipa_spell_db[] = $ipa_array->ipa_value;
      }
        return array(
          'status' => true,
          'type' => 'db',
          'text' => $ipa_spell_db
        );
    }

    else {
    $curl_handle = curl_init();
    curl_setopt($curl_handle, CURLOPT_URL,$url);
    curl_setopt($curl_handle, CURLOPT_CONNECTTIMEOUT, 2);
    curl_setopt($curl_handle, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curl_handle, CURLOPT_SSL_VERIFYPEER, 0);
    curl_setopt($curl_handle, CURLOPT_USERAGENT, 'Your application name');
    $query = curl_exec($curl_handle);
    curl_close($curl_handle);
    $res = json_decode($query);
    $ph_keyword = '';
    if(!$res->phonetic_transcription){
      return array(
        'status' => false,
        'errorMessage' => 'Unable to convert this word, Try again'
      );
    }
    foreach($res->phonetic_transcription as $value){
      if(isset($value->transcriptions)) {
      foreach($value->transcriptions as $val) {
        $ipa_spell[] = $val;
      }
    }
  }

  //To insert data from api response into db
  foreach($ipa_spell as $ipa_val) {
    $wpdb->insert('wp_phoneme_ipa', array(
      'phrase' => $phrase,
      'ipa_value' => $ipa_val
    ));
  }
    return array(
      'status' => true,
      'type' => 'api',
      'text' => $ipa_spell
    );
  }
}
  catch(Exception $e) {
    return array(
      'status' => false,
      'errorMessage' => 'Unable to convert this word, Try again'
    );
  }
}

add_action( 'rest_api_init', function () {
  register_rest_route( 'ssml/v1', 'phoneme/(?P<text>[a-zA-Z0-9_ ]+)/(?P<format>[a-zA-Z0-9- ]+)', array(
    'methods' => 'GET',
    'callback' => 'easy_pronunciation',
  ) );
} );

add_action( 'rest_api_init', function () {
  register_rest_route( 'ssml/v1', 'process-project-name/(?P<text>[a-zA-Z0-9_ ]+)', array(
    'methods' => 'GET',
    'callback' => 'processProjName',
  ) );
} );
add_action( 'rest_api_init', function () {
  register_rest_route( 'ssml/v1', 'delete-project/(?P<text>[a-zA-Z0-9_ ]+)', array(
    'methods' => 'GET',
    'callback' => 'deleteProject',
  ) );
} );
add_action( 'rest_api_init', function () {
  register_rest_route( 'ssml/v1', 'add-project/(?P<text>[\s\S]+)/(?P<user_id>[a-zA-Z0-9_ ]+)', array(
    'methods' => 'GET',
    'callback' => 'addProject',
  ) );
} );
add_action( 'rest_api_init', function () {
  register_rest_route( 'ssml/v1', 'load-project/(?P<text>[a-zA-Z0-9_ ]+)', array(
    'methods' => 'GET',
    'callback' => 'loadProject',
  ) );
} );
include_once 'adminend.php';
include_once 'frontend.php';

\SSMLP\Adminend::get_instance()->init();
\SSMLP\Frontend::get_instance()->init();

global $ssmlp_db_version;
$ssmlp_db_version = '1.0';

function ssmlp_install() {
	global $wpdb;
	global $ssmlp_db_version;

	$table_name = $wpdb->prefix . 'ssmlp_history';

	$charset_collate = $wpdb->get_charset_collate();

	$sql = "CREATE TABLE IF NOT EXISTS `wp_ssmlp_audios` (
      `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,
      `name` varchar(255) NOT NULL,
      `link` varchar(255) NOT NULL,
      `format` varchar(255) NOT NULL,
      `deleted` int(11) NOT NULL,
      PRIMARY KEY (`id`)
    ) ENGINE=InnoDB DEFAULT CHARSET=latin1;

    CREATE TABLE IF NOT EXISTS `wp_phoneme_ipa` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT PRIMARY KEY,
  `phrase` text NOT NULL,
  `ipa_value` varchar(20) NOT NULL,
  UNIQUE (ipa_value),
  `ipa_audio` varchar(500) NOT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE IF NOT EXISTS `wp_ssmlp_project` (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `created_by` int(11) NOT NULL,
  `created_on` datetime NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;

CREATE TABLE IF NOT EXISTS `wp_ssmlp_history` (
  `id` bigint(20) UNSIGNED NOT NULL AUTO_INCREMENT,
  `project_id` int(50) NOT NULL,
  `file_name` varchar(255) NOT NULL,
  `text` text CHARACTER SET utf8 NOT NULL,
  `url` varchar(255) NOT NULL,
  `date` datetime NOT NULL,
  `user_id` int(11) NOT NULL,
  `deleted` int(11) NOT NULL,
  `filesize` int(11) NOT NULL,
  `textsize` int(11) NOT NULL,
  `filename` text NOT NULL,
  `filepath` text NOT NULL,
  `start_aud` text DEFAULT NULL,
  `background_aud` text DEFAULT NULL,
  `end_aud` text DEFAULT NULL,
  `samplerate` int(11) NOT NULL,
  `bitrate` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

ALTER TABLE `wp_ssmlp_history` 
ADD COLUMN IF NOT EXISTS `project_id` int(50) NOT NULL,
ADD COLUMN IF NOT EXISTS `file_name` varchar(255) NOT NULL

    ";

	require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
	dbDelta( $sql );

	add_option('ssmlp_db_version', $ssmlp_db_version);
}
register_activation_hook( __FILE__, 'ssmlp_install' );
include_once 'd2l-wp-colorpicker.php';

function ssml_activation_redirect( $plugin ) {
  exit(wp_redirect(admin_url( 'admin.php?page=ssmlp_settings')));
}
add_action( 'activated_plugin', 'ssml_activation_redirect' );


function ssml_styles() {
  wp_enqueue_style( 'my-plugin-custom-styles', plugins_url('\assets\css\style.css' , __FILE__ ) );
}

add_action( 'wp_enqueue_scripts', 'ssml_styles' );
