<?php 
  $limit = isset($attr['limit'])?$attr['limit']:10;
  global $wpdb;
  $id = get_current_user_id();
  $rows = $wpdb->get_results("SELECT * FROM wp_ssmlp_history 
    WHERE `user_id` = $id
    AND `deleted` = 0
    ORDER BY id DESC 
    LIMIT $limit"
  );
?>
<h2>Recent Conversions</h2>
<table class="wp-list-table widefat fixed striped ">
    <thead>
      <tr>
        <th>Date</th>
        <th>SSML</th>
        <th>AUDIOS</th>
        <th>Action</th>
      </tr>
    </thead>
    <tbody>
      <?php foreach($rows as $v):?>
        <tr>
          <td class="ssmlp_history_date_col"><?= date("d M, Y  h:m:s A", strtotime($v->date));?></td>
          <td class="ssmlp_history_ssml_col">
              <span data-text="<?=htmlspecialchars(json_encode(['ssml'=>$v->text]), ENT_QUOTES, 'UTF-8');?>">
                <?=$v->text;?>
              </span>
          </td>
          <td class="">
            <?php 
            $s_aud = explode("/",$v->start_aud);
            $b_aud = explode("/",$v->background_aud);
            $e_aud = explode("/",$v->end_aud);

            $s_aud_name = end($s_aud);
            $b_aud_name = end($b_aud);
            $e_aud_name = end($e_aud);

            if($s_aud_name != null){
            ?>
              <span class="audname">Start : <?=$s_aud_name?></span><br>
            <?php }

            if($b_aud_name != null){
            ?>
              <span class="audname">Background : <?=$b_aud_name?></span><br>
            <?php } 

            if($e_aud_name != null){
            ?>
              <span class="audname">End : <?=$e_aud_name?></span><br>
            <?php } ?>
          </td>
          <td class="ssmlp_history_actions_col">
            <a href="<?=$v->url;?>" title="Download">
              <i class="fa fa-download"></i>
            </a>
            <a href="#ssmlp_editorbox" onclick="ssmlp_copy(this,'<?=$v->id;?>')">
              <i class="fa fa-copy" title="Copy to editor"></i>
            </a>
            <!-- <a href="#ssmlp_editorbox" onclick="return ssmlp_delete('<?=$v->id;?>');">
              <i class="fa fa-trash" title="Delete"></i>
            </a> -->
          </td>
        </tr>
      <?php endforeach;?>
    </tbody>
</table>