<?php 
use SSMLP\Enum;

$ssmlp_aws_accesskey = get_option("ssmlp_aws_accesskey");
$ssmlp_aws_secretkey = get_option("ssmlp_aws_secretkey");
$s3_bucket = get_option("s3_bucket");
// $license_key = get_option("license_key");

$samplerate = get_option("ssmlp_samplerate");
$voice = get_option("ssmlp_voice");
$video = get_option("ssmlp_video");
$additional_css = get_option("ssmlp_additional_css");
?>
<h1><?= get_admin_page_title(); ?></h1>

<form action="<?=admin_url('admin.php');?>" method="post">
  <input type="hidden" name="action" value="ssmlp_savesettings">
  <table class="form-table">
    <tr>
      <th scope="row"><label for="aws_accesskey">AWS Access Key</label></th>
      <td><input name="aws_accesskey" type="text" id="aws_accesskey" value="<?=$ssmlp_aws_accesskey; ?>" class="regular-text"></td>
    </tr>
    <tr>
      <th scope="row"><label for="aws_secretkey">AWS Secret Key</label></th>
      <td><input name="aws_secretkey" type="text" id="aws_secretkey" value="<?=$ssmlp_aws_secretkey; ?>" class="regular-text"></td>
    </tr>
    <tr>
      <th scope="row"><label for="bucket">Bucket Name</label></th>
      <td><input name="bucket" type="text" id="bucket" value="<?=$s3_bucket; ?>" class="regular-text"></td>
    </tr>
    <tr>
      <th scope="row"><label for="samplerate">Sample Rate (Default)</label></th>
      <td>
        <select id="samplerate" name="samplerate">
        <?php foreach(Enum::$ssmlp_samplerates as $k=>$v):?>
          <option value="<?=$k?>" <?=$k==$samplerate?"selected":""?>>
            <?=$v?>
          </option>
        <?php endforeach;?>
        </select>
      </td>
    </tr>
    <!-- <tr>
      <th scope="row"><label for="license_key">Serial key</label></th>
      <td><input name="license_key" type="text" id="license_key" value="<?=$license_key; ?>" class="regular-text"></td>
    </tr> -->
    <tr>
      <th scope="row"><label for="voice">Voice (Default)</label></th>
      <td>
        <select id="voice" name="voice">
        <?php foreach(Enum::$ssmlp_voices as $gk=>$gv):?>
          <optgroup label="<?=$gk;?>">
            <?php foreach($gv as $vk=>$vv):?>
            <option value="<?=$vk?>" <?=$vk==$voice?"selected":""?>>
              <?=$vv?>
            </option>
            <?php endforeach;?>
          </optgroup>
        <?php endforeach;?>
        </select>
      </td>
    </tr>
    <tr>
      <th scope="row"><label for="video">Video URL</label></th>
      <td><input name="video" type="text" id="video" value="<?=$video; ?>" class="regular-text"></td>
    </tr>
    <tr>
      <th scope="row"><label for="">Additional CSS</label></th>
      <td><?php echo '<textarea id="fancy-textarea" name="additional_css">' . $additional_css . '</textarea>';?></td>
    </tr>
    
  </table>
  <p class="submit"><input type="submit" name="submit" id="submit" class="button button-primary" value="Save Changes"></p>
</form>

<script>
  jQuery(document).ready(function($) {
  wp.codeEditor.initialize($('#fancy-textarea'), cm_settings);
})
</script>

<script>
  jQuery('#i_file').change( function(event) {
    var tmppath = URL.createObjectURL(event.target.files[0]);
    jQuery("#tmp_path").val(tmppath);
});
</script>
