<?php 
    $months = [
        '1' => 'January',
        '2' => 'February',
        '3' => 'March',
        '4' => 'April',
        '5' => 'May',
        '6' => 'June',
        '7' => 'July',
        '8' => 'August',
        '9' => 'September',
        '10' => 'October',
        '11' => 'November',
        '12' => 'December',
    ];

    $years = [];
    for ($i=date('Y'); $i>=2019 ; $i--) { 
        array_push($years,$i);
    }
    
    $users = get_users(); 
    global $wpdb;
    if(isset($_GET['month']) && isset($_GET['year'])){
        $month = $_GET['month'];
        $year = $_GET['year'];
    }
    else{
        $month = date('m');
        $year = date('Y');
    }
?>
<div class="wrap">
    <h1 class="wp-heading-inline">Users</h1>
    <!--  -->
    <div class="tablenav top">
        <div class="alignleft actions bulkactions">
            <form action="<?=admin_url()."admin.php"?>">
            <label for="bulk-action-selector-top" class="screen-reader-text">Select Month</label>
            <input type='hidden' name="page" value="ssmlp_user_stats" >
            <select name="month" id="bulk-action-selector-top">
            <option value="<?=$month?>" hidden selected><?=$months[$month]?></option>
                <?php foreach($months as $k=>$v):?>
                    <option value="<?=$k?>">
                        <?=$v?>
                    </option>
                <?php endforeach;?>
            </select>
            <select name="year" id="bulk-action-selector-top">
            <option value="<?=$year?>" hidden selected><?=$year?></option>
                <?php foreach($years as $k=>$v):?>
                    <option value="<?=$v?>">
                        <?=$v?>
                    </option>
                <?php endforeach;?>
            </select>
            <input type="submit" id="doaction" class="button action" value="Apply">
            </form>
        </div>
        <br class="clear">
    </div>
    <!--  -->
    <table class="wp-list-table widefat fixed striped users">
	    <thead>
	        <tr>
                <th scope="col" id="username" class="manage-column column-username column-primary sorted asc">
                    <a href="<?=admin_url()."admin.php?page=ssmlp_user_stats&orderby=login&order=desc"?>">
                        <span>Username</span>
                    </a>
                </th>
                <th scope="col" id="conversions" class="manage-column column-username">No of Conversions</th>
                <th scope="col" id="role" class="manage-column column-role">Role</th>
            </tr>
        </thead>
	    <tbody id="the-list" data-wp-lists="list:user">
            <?php foreach ($users as $user):?>
            <?php   
                $id = $user->ID;
                $result = $wpdb->get_results ( "SELECT *,COUNT(*) AS 'count' FROM wp_ssmlp_history WHERE `user_id` = $id AND MONTH(date) = $month AND YEAR(date) = $year" );
                $count = $result[0]->count;
                $edit = get_edit_user_link($id);
            ?>
	        <tr id="user-1">
                <td class="username column-username has-row-actions column-primary" data-colname="Username">
                    <strong>
                        <a href=""><?=$user->user_nicename?></a>
                    </strong>
                    <br>
                    <div class="row-actions">
                        <span class="edit">
                            <a href="<?=$edit?>">Edit</a>
                        </span>
                    </div>
                    <button type="button" class="toggle-row">
                        <span class="screen-reader-text">Show more details</span>
                    </button>
                </td>
                <td class="role column-role" data-colname="Role"><?=$count?></td>
                <td class="role column-role" data-colname="Role"><?=$user->roles[0]?></td>
            </tr>
            <?php endforeach;?>
	    </tbody>
    </table>
</div>
